=== debian/changelog ===
sdrangel (7.22.10-1) unstable; urgency=medium

    * See Github release

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Mon, 22 Dec 2025 08:26:27 +0100

sdrangel (7.22.9-1) unstable; urgency=medium

    * See Github release

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sun, 28 Sep 2025 15:58:05 +0200

sdrangel (7.22.8-1) unstable; urgency=medium

    * See Github release

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Wed, 02 Jul 2025 17:00:39 +0200

sdrangel (7.22.7-1) unstable; urgency=medium

    * See Github release

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sun, 04 May 2025 17:58:14 +0200

sdrangel (7.22.6-1) unstable; urgency=medium

    * See Github release

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sun, 02 Feb 2025 18:08:11 +0100

sdrangel (7.22.5-1) unstable; urgency=medium

    * Windows: upload signed releases rather than unsigned releases to Github releases page. PR #2347
    * Windows: fixed signed releases. PR #2344
    * FT8 Demod: limit upper bandwidth to 5.8 kHz. Fixes #2339
    * Stop device while changing channel set. Fixes #2332. PR #2342
    * ADSB: Update URL of OpenSkyNetwork Aircraft database. PR #2341
    * Don't stop source if being deleted. For #2315. PR #2340
    * Send DSPSignalNotification in audio mods for #2336. PR #2340
    * Radiosonde: limit precision of floating point numbers sent to SondeHub. PR #2338
    * Windows signed releases: use relative path. Increase timeout to 30 minutes. PR #2335
    * ADSB: Include adsbdemodsettings.h PR #2334
    * Use release signing certificate for Windows installer. PR #2331
    * Fix memory leak and race condition relating to DSP*Engines. Part of #2159 PR #2330
    * FreeDV: Fix memory allocation/free issues. Part of #2315. PR #2330
    * Wav Files: Add support for meta-data. PR #2328
    * DemodAnalyzer: Ensure sample rate is set in worker. Fixes #2309. PR #2328
    ^ SDRplayv3: Mac: link with libsdrplay_api.so.3 rather than libsdrplay_api.so.3.15. PR #2327
    * ADS-B: Fix memory use after delete. For #1734 and part of #2315 PR #2326
    * Fixed Appveyor Docker image build
    * Fix output-artifact-directory and unzip file. PR #2323

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Thu, 05 Dec 2024 01:07:27 +0100

sdrangel (7.22.4-1) unstable; urgency=medium

    * Use macos-12 for Mac x86 build. PR #2321
    * Workaround for "hdiutil: create failed - Resource busy"
    * Pager: Add alpha and numeric columns. Implements #2319. PR #2320
    * Added qtwebchannel dependecy to fix missing 3d Map and Sky Map from Windows release. PR #2316
    * Removed .deb package build from Appveyor

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Mom, 11 Nov 2024 08:42:03 +0100

sdrangel (7.22.3-1) unstable; urgency=medium

    * Add deb dependencies for pipewire. PR #2314
    * Added compilation options for WebAssembly. PR #2313
    * ADS-B: Use settings keys. PR #2310
    * AIS Demod: Remove spacing around messages. PR #2310
    * Freuqency Scanner: Add multiplex mode. PR #2310
    * Build snap, MAC, Windows and Ubuntu .deb with Github actions. Various PRs
    * Server: Use Sink/MIMO signals rather than Source. Part of #2294. PR #2304
    * Updated some Python scripts to Python3. PR #2298
    * RemoteTCPSink: Does use IQ only setting for RTL0. PR #2301
    * Server: wait for set sample source/sink/MIMO to complete before loading the device settings. Fixes #2294
    * Fix spectrum peak measurement for SSB spectra. Fixes #2282. PR #2299
    * Upgrade C++ standard to c++17
    * Fixes for Android . PR #2288
    * Add qtshadertools. PR #2287
    * Add more Qt modules and set ENABLE_QT6=ON. PR #2287
    * Update Qt optional packages for 6.8 , PR #2287
    * Use Qt 6.8 for Windows build. PR #2287

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sat, 09 Nov 2024 17:30:44 +0100

sdrangel (7.22.2-1) unstable; urgency=medium

    * ChirpChat: increased preamble symbols limit from 20 to 32. Fixes #2284
    * RTLSDR: Apply driver settings in RTLSDRThread Add sync read for WebAssembly. PR #2281
    * SSB demod: fixed GUI and returned to previous threading model. Fixes #2273
    * HeatMap: Catch memory allocation failures... For #2083 PR #2277
    * Add default-qt6-windows cmake config. PR #2276
    * Add pager notifications. Add option to ignore duplicates. Support plotting pager messages on the map. PR #2276
    * Don't load defaults if loading a preset. PR #2274
    * DeviceGUI::closeEvent - Don't automatically delete the GUI,.. PR #2274
    * MainWindow: Add FSMs to avoid blocking on the GUI thread... PR #2274
    * Fix replay buffer when FixReal is qint16. PR #2270
    * snap: Try to get version number from latest tag. PR #2270
    * Add libflac to snap. Set ARCH_OPT to nehalem. PR #2270
    * Fix flac on Mac. PR #2270
    * RemoteTCP: Update docs. PR #2270
    * Map: Fix Kiwi list. Add SDRangel wss support. PR #2270
    * RemoteTCPSink: Report server init errors via GUI. Send protocol to public list. PR #2270
    * RemoteTCPInput: Add wss protocol support. PR #2270
    * Fix DeviceAPI::deserialize. Fixes #2266. PR #2267

   -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sun, 20 Oct 2024 08:26:38 +0200

sdrangel (7.22.1-1) unstable; urgency=medium

    * wdsprx: Fix path to help file.
    * Removed SyncMessenger from DSPDeviceSourceEngine. Part of #2159
    * Fixed threading model for DSPDeviceSourceEngine. Part of #2159
    * Removed SyncMessenger from DSPDeviceMIMOEngine. Part of #2159
    * RTLSDR: make sure start and stop are effective once only. PArt of #2159
    * Fixed threading model for DSPDeviceMIMOEngine plus other fixes. Part of #2159
    * Removed SyncMessenger from DSPDeviceSinkEngine. Part of #2159
    * SSBMod, AMMod, NFMMod: revised thread processing
    * Fixed threading model for DSPDeviceSinkEngine plus other fixes. Part of #2159
    * DeviceSet and DeviceUISet: use delete channel API instead of destroy method...

